package com.ic.modules.auth.service.impl;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Isolation;
import org.springframework.transaction.annotation.Transactional;

import com.ic.constant.DBConfig;
import com.ic.exception.ResourceNotFoundException;
import com.ic.modules.auth.model.Configurations;
import com.ic.modules.auth.payload.ConfigurationsDto;
import com.ic.modules.auth.repository.ConfigurationsRepository;
import com.ic.modules.auth.service.ConfigurationsService;

@Service
public class ConfigurationsServiceImpl implements ConfigurationsService {

	@Autowired
	ConfigurationsRepository configRepo;
	
	DBConfig DBConfig;
	
	@Autowired
    public ConfigurationsServiceImpl(@Lazy DBConfig DBConfig) {
        this.DBConfig = DBConfig;
    }
	
	public Configurations save(ConfigurationsDto dto,Boolean isCreate) {
		 Configurations configuration = null;
		 if(!isCreate) {
			 configRepo.findByProperty(dto.getKey()).orElseThrow(()->new ResourceNotFoundException("Config","key",dto.getKey()));
		 }else {
			 configuration = new Configurations();
			 configuration.setProperty(dto.getKey());
		 }
		 configuration.setValue(dto.getValue());
		 configuration.setDescription(dto.getDescription());
		 DBConfig.setValue(dto.getKey(), dto.getValue());
		 return configRepo.save(configuration);
		 
	 }
	@Transactional(isolation=Isolation.READ_UNCOMMITTED)
	 public List<Configurations> findAll(){
		 return configRepo.findAll();
	 }
	@Transactional(isolation=Isolation.READ_UNCOMMITTED)
	 public Configurations findByKey(String key) {
		 return configRepo.findByProperty(key).orElseThrow(()->new ResourceNotFoundException("Config","key",key));
	 }
	 
}
