package com.ic.modules.auth.service.impl;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Isolation;
import org.springframework.transaction.annotation.Transactional;

import com.ic.constant.LeaderCalcConfig;
import com.ic.exception.ResourceNotFoundException;
import com.ic.modules.auth.model.DTSlabsMapping;
import com.ic.modules.auth.payload.DTslabsDto;
import com.ic.modules.auth.repository.DTslabsRepository;
import com.ic.modules.auth.service.DTslabsService;


@Service
public class DTslabsMappingServiceImpl implements DTslabsService {

	@Autowired
	DTslabsRepository dtslabsrepo;

	LeaderCalcConfig LeaderCalcConfig;

	@Autowired
    public DTslabsMappingServiceImpl(@Lazy LeaderCalcConfig LeaderCalcConfig) {
        this.LeaderCalcConfig = LeaderCalcConfig;
    }
	
	@Override
	@Transactional(isolation=Isolation.READ_UNCOMMITTED)
	public List<DTSlabsMapping> findAll() {  // neel gosrani 27-05-2020 Activation DT CR Function for fetch all data from DB   // neel gosrani 02-09-2020 Sql server migration
	
		return dtslabsrepo.findAll();
	}
	
	public DTSlabsMapping save(DTslabsDto dto, Boolean isCreate) {   // neel gosrani 27-05-2020 Activation DT CR Function for save all data to DB
		if(!isCreate) {
			dtslabsrepo.findById(dto.getId()).orElseThrow(()->new ResourceNotFoundException("dtslabs","key",dto.getId()));
		 }
		
		DTSlabsMapping dtslabsMapping = null;
		
		dtslabsMapping= new DTSlabsMapping();
		dtslabsMapping.setId(dto.getId());
		dtslabsMapping.setCBA(dto.getCBA());
		dtslabsMapping.setBA(dto.getBA());
		dtslabsMapping.setSBA(dto.getSBA());
		dtslabsMapping.setMaxval(dto.getMaxval());
		dtslabsMapping.setMinval(dto.getMinval());
		dtslabsMapping.setPartner(dto.getPartner());
		dtslabsMapping.setSenior_Partner(dto.getSenior_Partner());
		
		return dtslabsrepo.save(dtslabsMapping);
	}

	

}
