package com.ic.modules.auth.service.impl;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Isolation;
import org.springframework.transaction.annotation.Transactional;

import com.ic.constant.LeaderCalcConfig;
import com.ic.exception.ResourceNotFoundException;
import com.ic.modules.auth.model.L2slabsMapping;
import com.ic.modules.auth.payload.L2slabsDto;
import com.ic.modules.auth.repository.L2slabsRepository;
import com.ic.modules.auth.service.L2slabsMappingService;




@Service
public class L2slabsMappingServiceImpl implements L2slabsMappingService {

	@Autowired
	L2slabsRepository l2slabsRepo;
	
	LeaderCalcConfig LeaderCalcConfig;
	
	@Autowired
    public L2slabsMappingServiceImpl(@Lazy LeaderCalcConfig LeaderCalcConfig) {
        this.LeaderCalcConfig = LeaderCalcConfig;
    }
	
	@Override
	@Transactional(isolation=Isolation.READ_UNCOMMITTED)
	public List<L2slabsMapping> findAll() {    // neel gosrani 02-09-2020 Sql server migration
		// TODO Auto-generated method stub
		 return l2slabsRepo.findAll();
	}
	
	public L2slabsMapping save(L2slabsDto dto,Boolean isCreate) {


		if(!isCreate) {
			l2slabsRepo.findById(dto.getId()).orElseThrow(()->new ResourceNotFoundException("l2slabs","key",dto.getId()));
		 }
		
		L2slabsMapping l2slabsmapping = null;

		l2slabsmapping = new L2slabsMapping();
		l2slabsmapping.setId(dto.getId());
		l2slabsmapping.setCBA(dto.getCBA());
		l2slabsmapping.setSBA(dto.getSBA());
		l2slabsmapping.setMaxval(dto.getMaxval());
		l2slabsmapping.setMinval(dto.getMinval());
		l2slabsmapping.setPartner(dto.getPartner());
		l2slabsmapping.setSenior_Partner(dto.getSenior_Partner());

		return l2slabsRepo.save(l2slabsmapping);

	}

}
