package com.ic.modules.auth.service.impl;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Isolation;
import org.springframework.transaction.annotation.Transactional;

import com.ic.constant.LeaderCalcConfig;
import com.ic.exception.ResourceNotFoundException;
import com.ic.modules.auth.model.MDBMapping;
import com.ic.modules.auth.payload.MDBDto;
import com.ic.modules.auth.repository.MDBRepository;
import com.ic.modules.auth.service.MDBMappingService;

@Service
public class MDBMappingServiceImpl implements MDBMappingService {

	@Autowired
	MDBRepository mdbrepo;
	
	LeaderCalcConfig LeaderCalcConfig;

	@Autowired
    public MDBMappingServiceImpl(@Lazy LeaderCalcConfig LeaderCalcConfig) {
        this.LeaderCalcConfig = LeaderCalcConfig;
    }
	
	@Override
	@Transactional(isolation=Isolation.READ_UNCOMMITTED)
	public List<MDBMapping> findAll() {    // neel gosrani 02-09-2020 Sql server migration
		// TODO Auto-generated method stub
		 return mdbrepo.findAll();
	}


	@Override
	public MDBMapping save(MDBDto dto,Boolean isCreate) {
		

		if(!isCreate) {
			mdbrepo.findById(dto.getID()).orElseThrow(()->new ResourceNotFoundException("mdb","key",dto.getID()));
		 }
		MDBMapping mdbmapping = null;
		mdbmapping = new MDBMapping();
		mdbmapping.setId(dto.getID());
		mdbmapping.setMDB(dto.getMDB());
		mdbmapping.setMonthly_ep_144(dto.getMonthly_ep_144());
		mdbmapping.setMonthly_ep_18(dto.getMonthly_ep_18());
		mdbmapping.setMonthly_ep_36(dto.getMonthly_ep_36());
		mdbmapping.setMonthly_ep_72(dto.getMonthly_ep_72());

		return mdbrepo.save(mdbmapping);
	}
}
